
module My
  class ReadLine
    include Enumerable

    def initialize input = nil, &block
      @input = input || Enumerator.new(&block)
    end

    def each
      last_line = ''
      @input.each do |chunk|
        chunk.each_line do |line|
          if line[-1] == "\n"
            unless last_line.empty?
              last_line << line
              line, last_line = last_line, ''
            end
            yield line
          else
            last_line << line
          end
        end
      end
      yield last_line unless last_line.empty?
    end

  end
end
